=== debian/tests/control ===
Tests: test-link
Depends: build-essential, libngspice0-dev, pkg-config
Restrictions: allow-stderr
